<?php
// admin notices
add_action( 'admin_notices', 'wpbforwpbakerypro_check_woocommerce_status' );

// This notice for WooCommerce is not installed or activated or both.
function wpbforwpbakerypro_check_woocommerce_status(){
    $woocommerce = 'woocommerce/woocommerce.php';
    $button_text = '';

    if(! wpbforwpbakerypro_is_plugins_installed($woocommerce) ) {
    	if( ! current_user_can( 'activate_plugins' ) ) {
    	    return;
    	}
    	$activation_url = wp_nonce_url( self_admin_url( 'update.php?action=install-plugin&plugin=woocommerce' ), 'install-plugin_woocommerce' );
    	$message = sprintf( esc_html__( 'WC Page Builder Pro requires %1$s"WooCommerce"%2$s plugin to be installed and activated. Please install WooCommerce to continue.', 'wpbforwpbakerypro' ), '<strong>', '</strong>' );
    	$button_text = esc_html__( 'Install WooCommerce', 'wpbforwpbakerypro' );

    }  else if(wpbforwpbakerypro_is_plugins_installed($woocommerce) && !wpbforwpbakerypro_is_plugins_active($woocommerce)){

    	if( ! current_user_can( 'activate_plugins' ) ) {
    	    return;
    	}
    	$activation_url = wp_nonce_url( 'plugins.php?action=activate&amp;plugin=' . $woocommerce . '&amp;plugin_status=all&amp;paged=1&amp;s', 'activate-plugin_' . $woocommerce );
    	$message = sprintf( esc_html__( 'WC Page Builder Pro requires %1$s"WooCommerce"%2$s plugin to be active. Please activate WooCommerce to continue.', 'wpbforwpbakerypro' ), '<strong>', '</strong>');
    	$button_text = esc_html__( 'Activate WooCommerce', 'wpbforwpbakerypro' );

    }

    if($button_text){
    	$button = '<p><a href="' . esc_url($activation_url) . '" class="button-primary">' . $button_text . '</a></p>';
    	printf( '<div class="error"><p>%1$s</p>%2$s</div>', $message, $button );
    }
}


add_action( 'admin_notices', 'wpbforwpbakerypro_render_vc_install_active_notice' );
function wpbforwpbakerypro_render_vc_install_active_notice(){
    $vc = wpbforwpbakerypro_find_vc_installed();

    if( !$vc ){
        // not installed notice
        if( ! current_user_can( 'activate_plugins' ) ) {
            return;
        }
        $activation_url = 'https://codecanyon.net/item/visual-composer-page-builder-for-wordpress/242431';
        $message = sprintf( esc_html__( 'WC Builder Pro requires %1$s"WPBakery Page Builder"%2$s plugin to be installed and activated. Please install WPBakery Page Builder to continue.', 'wpbforwpbakerypro' ), '<strong>', '</strong>' );
        $button_text = esc_html__( 'Get It Now', 'wpbforwpbakerypro' );


        $button = '<p><a href="' . $activation_url . '" class="button-primary">' . $button_text . '</a></p>';
        printf( '<div class="error"><p>%1$s</p>%2$s</div>', __( $message ), $button );
    } else if(wpbforwpbakerypro_is_plugins_installed($vc) && !wpbforwpbakerypro_is_plugins_active($vc)){
        if( ! current_user_can( 'activate_plugins' ) ) {
            return;
        }
        $activation_url = wp_nonce_url( 'plugins.php?action=activate&amp;plugin=' . $vc . '&amp;plugin_status=all&amp;paged=1&amp;s', 'activate-plugin_' . $vc );
        $message = esc_html__( 'WC Builder Pro requires WPBakery Page Builder plugin to be active. Please activate WPBakery Page Builder to continue.', 'wpbforwpbakerypro' );
        $button_text = esc_html__( 'Activate WPBakery Page Builder', 'wpbforwpbakerypro' );

        $button = '<p><a href="' . $activation_url . '" class="button-primary">' . $button_text . '</a></p>';
        printf( '<div class="error"><p>%1$s</p>%2$s</div>', __( $message ), $button );
    }
}