<?php
class WPBForWPbakeryPro_Checkout_Additional_Form{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_checkout_additional_form', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'label_color' => '', 
            'label_font_size' => '', 
            'label_line_height' => '', 
            'input_box_color' => '', 
            'input_box_font_size' => '', 
            'input_box_line_height' => '', 
            'el_class' => '', 
            'wrapper_css' => '', 
        ),$atts));

        if( is_checkout() ){
        	ob_start();

        	$unique_class = uniqid('wpbforwpbakerypro_');
        	$output = '<style>';

            $output .= ".woocommerce-checkout .$unique_class .form-row{display:block; }";

        	$output .= ".woocommerce-checkout .$unique_class .form-row label{color:{$label_color};font-size:{$label_font_size}; line-height:{$label_line_height}; }";
        	$output .= ".woocommerce-checkout .$unique_class textarea{color:{$input_box_color};font-size:{$input_box_font_size}; line-height:{$input_box_line_height}; }";
        	$output .= '</style>';

        	echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

        	    $checkout = WC()->checkout();
        	    if ( sizeof( $checkout->checkout_fields ) > 0 ) { ?>
        	        <div class="woocommerce-additional-fields">
        	            <?php do_action( 'woocommerce_before_order_notes', $checkout ); ?>
        	        
        	            <?php if ( apply_filters( 'woocommerce_enable_order_notes_field', 'yes' === get_option( 'woocommerce_enable_order_comments', 'yes' ) ) ) : ?>
        	        
        	                <?php if ( ! WC()->cart->needs_shipping() || wc_ship_to_billing_address_only() ) : ?>
        	                    <h3><?php _e( 'Additional information', 'wpbforwpbakerypro' ); ?></h3>
        	                <?php endif; ?>
        	
        	                <div class="woocommerce-additional-fields__field-wrapper">
        	                    <?php foreach ( $checkout->get_checkout_fields( 'order' ) as $key => $field ) : ?>
        	                        <?php woocommerce_form_field( $key, $field, $checkout->get_value( $key ) ); ?>
        	                    <?php endforeach; ?>
        	                </div>
        	        
        	            <?php endif; ?>
        	        
        	            <?php do_action( 'woocommerce_after_order_notes', $checkout ); ?>
        	        </div>
        	    <?php
        	    }

    		echo '</div>';
    	    return $output.= ob_get_clean();
    	}
    }


    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: Checkout Additional Form", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_checkout_additional_form",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_checkout_additional_form_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'label_color',
            	    'heading' => esc_html__( 'Label Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'label_font_size',
            	    'heading' => esc_html__( 'Label Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'label_line_height',
            	    'heading' => esc_html__( 'Label Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'input_box_color',
            	    'heading' => esc_html__( 'Input Box Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'input_box_font_size',
            	    'heading' => esc_html__( 'Input Box Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'input_box_line_height',
            	    'heading' => esc_html__( 'Input Box Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}
new WPBForWPbakeryPro_Checkout_Additional_Form();