<?php
class WPBForWPbakeryPro_Myaccount_Address{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_myaccount_address', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
        	'heading_color' => '',
        	'heading_font_size'	=> '',
        	'heading_line_height'	=> '',
        	'content_color'	=> '',
        	'content_font_size'	=> '',
        	'content_line_height'	=> '',
            'el_class' => '', 
            'wrapper_css' => '', 
        ), $atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_myaccount_address_');
        $output = '<style>';

        $output .= ".woocommerce-account .$unique_class .col-1,.woocommerce-account .$unique_class .col-2{ max-width: 48%; }";
        $output .= ".woocommerce-account .$unique_class .addresses .title h3{color:{$heading_color};font-size:{$heading_font_size}; line-height:{$heading_line_height}; }";
        $output .= ".woocommerce-account .$unique_class address{color:{$content_color};font-size:{$content_font_size}; line-height:{$content_line_height}; }";
        $output .= '</style>';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

	       if ( ! is_user_logged_in() ) { return esc_html__('You need first to be logged in', 'wpbforwpbakerypro'); }
	       global $wp;
	       $type = '';
	       
	       if( isset( $wp->query_vars['edit-address'] ) ){
	           $type = $wp->query_vars['edit-address'];
	       }else{ $type = wc_edit_address_i18n( sanitize_title( $type ), true ); }
	       echo '<div class="my-accouunt-form-edit-address">';
	           \WC_Shortcode_My_Account::edit_address( $type );
	       echo '</div>';

    	echo '</div>';
        return $output.= ob_get_clean();
    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: My Aaccount Address", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_myaccount_address",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_myaccount_address_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'heading_color',
            	    'heading' => esc_html__( 'Heading Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'heading_font_size',
            	    'heading' => esc_html__( 'Heading Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'heading_line_height',
            	    'heading' => esc_html__( 'Heading Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'content_color',
            	    'heading' => esc_html__( 'Content Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'content_font_size',
            	    'heading' => esc_html__( 'Content Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'content_line_height',
            	    'heading' => esc_html__( 'Content Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}

new WPBForWPbakeryPro_Myaccount_Address();