<?php
class WPBForWPbakeryPro_Myaccount_Dashboard{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_myaccount_dashboard', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'text_color' => '',
            'text_font_size'	=> '',
            'text_line_height'	=> '', 
            'link_color'	=> '', 
            'link_hover_color'	=> '', 
            'el_class' => '', 
            'wrapper_css' => '', 
        ), $atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_');
        $output = '<style>';
        $output .= ".$unique_class p{color:{$text_color};font-size:{$text_font_size}; line-height:{$text_line_height}; }";
        $output .= ".$unique_class p a{color:{$link_color}; }";
        $output .= ".$unique_class p a:hover{color:{$link_hover_color}; }";
        $output .= '</style>';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

			if ( ! is_user_logged_in() ) { return esc_html__('You need to logged in first', 'wpbforwpbakerypro'); }
            wc_get_template( 'myaccount/dashboard.php', array(
                'current_user' => get_user_by( 'id', get_current_user_id() ),
            ) );
    	echo '</div>';
        return $output.= ob_get_clean();

    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: My Account Dashboard", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_myaccount_dashboard",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_myaccount_dashboard_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'text_color',
            	    'heading' => esc_html__( 'Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'text_font_size',
            	    'heading' => esc_html__( 'Text Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'text_line_height',
            	    'heading' => esc_html__( 'Text Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'link_color',
            	    'heading' => esc_html__( 'Link Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'link_hover_color',
            	    'heading' => esc_html__( 'Link Hover Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}
new WPBForWPbakeryPro_Myaccount_Dashboard();