<?php
class WPBForWPbakeryPro_Myaccount_Download{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_myaccount_download', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'el_class' => '', 
            'wrapper_css' => '', 
        ), $atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_myaccount_download_');
        $output = '';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

        if ( is_account_page() ) {
           do_action('woocommerce_account_downloads_endpoint');
        }

    	echo '</div>';
        return $output.= ob_get_clean();

    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: My Account Download", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_myaccount_download",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_myaccount_download_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}
new WPBForWPbakeryPro_Myaccount_Download();