<?php
class WPBForWPbakeryPro_Myaccount_Order{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_myaccount_order', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'bg_color' => '',
            'table_title_color' => '',
            'table_title_font_size' => '', 
            'table_title_line_height' => '', 
            'table_title_align' => '', 
            'table_cell_color' => '', 
            'table_cell_font_size' => '', 
            'table_cell_line_height' => '', 
            'table_cell_text_align' => '', 
            'table_cell_border' => '', 
            'table_cell_padding' => '', 
            'order_view_button_color' => '', 
            'order_view_button_bg_color' => '', 
            'order_view_button_padding' => '', 
            'order_view_button_border' => '', 
            'order_view_button_border_radius' => '', 
            'order_view_button_hover_color' => '', 
            'order_view_button_hover_bg_color' => '', 
            'order_view_button_hover_border' => '', 
            'el_class' => '', 
            'wrapper_css' => '', 
        ), $atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_');
        $output = '<style>';

        $output .= ".woocommerce .$unique_class .woocommerce-orders-table th.woocommerce-orders-table__header{color:{$table_title_color};font-size:{$table_title_font_size}; line-height:{$table_title_line_height}; text-align: {$table_title_align};}";
        $output .= ".woocommerce .$unique_class .woocommerce-orders-table tr.woocommerce-orders-table__row td.woocommerce-orders-table__cell{color:{$table_cell_color};background-color:{$bg_color}; font-size:{$table_cell_font_size}; line-height:{$table_cell_line_height}; text-align: {$table_cell_text_align}; border:{$table_cell_border};padding:{$table_cell_padding}; }";
        $output .= ".woocommerce .$unique_class .woocommerce-orders-table tr.woocommerce-orders-table__row td.woocommerce-orders-table__cell a.woocommerce-button{color:{$order_view_button_color};background-color:{$order_view_button_bg_color}; border:{$order_view_button_border};border-radius:{$order_view_button_border_radius}; padding:{$order_view_button_padding}; }";
        $output .= ".woocommerce .$unique_class .woocommerce-orders-table tr.woocommerce-orders-table__row td.woocommerce-orders-table__cell a.woocommerce-button:hover{color:{$order_view_button_hover_color};background-color:{$order_view_button_hover_bg_color}; border:{$order_view_button_hover_border}; }";

		$output .= '</style>';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

        global $wp;
        if ( ! is_user_logged_in() ) { return esc_html__('You need to logged in first', 'wpbforwpbakerypro'); }
        if( isset($wp->query_vars['orders']) ){
            $value = $wp->query_vars['orders'];
            do_action( 'woocommerce_account_orders_endpoint', $value );
                
        }elseif( isset($wp->query_vars['view-order']) ){
            $myaccount_url = get_permalink();
            $value = $wp->query_vars['view-order'];
            do_action( 'woocommerce_account_view-order_endpoint', $value );
            
        }else{
            $value = '';
            do_action( 'woocommerce_account_orders_endpoint', $value );
        }

		echo '</div>';
        return $output.= ob_get_clean();

    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: My Account Order", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_myaccount_order",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_myaccount_order_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'table_title_color',
            	    'heading' => esc_html__( 'Table Title Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'table_title_font_size',
            	    'heading' => esc_html__( 'Table Title Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'table_title_line_height',
            	    'heading' => esc_html__( 'Table Title Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'table_cell_color',
            	    'heading' => esc_html__( 'Table Cell Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'table_cell_font_size',
            	    'heading' => esc_html__( 'Table Cell Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'table_cell_line_height',
            	    'heading' => esc_html__( 'Table Cell Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	  "param_name" => "table_cell_text_align",
            	  "heading" => esc_html__("Table Cell Text Align", 'wpbforwpbakerypro'),
            	  "type" => "dropdown",
            	  "default_set" => 'left',
            	  'value' => wpbforwpbakerypro_text_align_lists(),
                  'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'table_cell_border',
            	    'heading' => esc_html__( 'Table Cell Border', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 1px solid red', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'table_cell_padding',
            	    'heading' => esc_html__( 'Table Cell Padding', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS padding. Example: 18px 0, which stand for padding-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'order_view_button_color',
            	    'heading' => esc_html__( 'Button Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'order_view_button_bg_color',
            	    'heading' => esc_html__( 'Button BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'order_view_button_padding',
            	    'heading' => esc_html__( 'Button Padding', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS padding. Example: 18px 0, which stand for padding-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'order_view_button_border',
            	    'heading' => esc_html__( 'Button Border', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 1px solid red', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'order_view_button_border_radius',
            	    'heading' => esc_html__( 'Button Border Radius', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS Border Radius. Example: 5px, which stand for border-radius:5px;', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'order_view_button_hover_color',
            	    'heading' => esc_html__( 'Button Hover Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'order_view_button_hover_bg_color',
            	    'heading' => esc_html__( 'Button Hover BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'order_view_button_hover_border',
            	    'heading' => esc_html__( 'Button Hover Border', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 1px solid red', 'wpbforwpbakerypro' ),
            	),
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", "wpbforwpbakerypro" ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}
new WPBForWPbakeryPro_Myaccount_Order();