<?php
class WPBForWPbakeryPro_Myaccount_Register_Form{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_myaccount_register_form', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'form_heading_color' => '', 
            'form_heading_font_size' => '', 
            'form_heading_line_height' => '', 
            'form_label_color' => '', 
            'form_label_font_size' => '', 
            'form_label_line_height' => '', 
            'form_text_color' => '', 
            'form_text_font_size' => '', 
            'form_text_line_height' => '', 
            'form_input_box_color' => '', 
            'form_input_box_font_size' => '', 
            'form_input_box_line_height' => '',
            'form_input_box_border' => '', 
            'form_input_box_border_radius' => '', 
            'form_input_box_padding' => '', 
        	'form_button_bg_color' => '',
        	'form_button_text_color' => '',
        	'form_button_margin' => '', 
        	'form_button_padding' => '', 
        	'form_button_hover_bg_color' => '',
        	'form_button_hover_text_color' => '',
            'el_class' => '', 
            'wrapper_css' => '', 
        ), $atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_');
        $output = '<style>';

        $output .= ".woocommerce .$unique_class h2{color:{$form_heading_color};font-size:{$form_heading_font_size}; line-height:{$form_heading_line_height};}";
        $output .= ".woocommerce .$unique_class .form-row label{color:{$form_label_color};font-size:{$form_label_font_size}; line-height:{$form_label_line_height};}";
        $output .= ".woocommerce .$unique_class p,.woocommerce .$unique_class a{color:{$form_text_color};font-size:{$form_text_font_size}; line-height:{$form_text_line_height};}";
        $output .= ".woocommerce .$unique_class .form-row input.input-text{color:{$form_input_box_color};font-size:{$form_input_box_font_size}; line-height:{$form_input_box_line_height}; border:{}; border-radius:{}; padding:{}; }";
        $output .= ".woocommerce .$unique_class button.button{color:{$form_button_text_color}; background-color:{$form_button_bg_color}; margin:{$form_button_margin}; padding:{$form_button_padding}; }";
        $output .= ".woocommerce .$unique_class button.button:hover{color:{$form_button_hover_text_color}; background-color:{$form_button_hover_bg_color}; }";

		$output .= '</style>';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

            if( !is_account_page() ){ do_action( 'woocommerce_before_customer_login_form' );}
            ?>
            <div class="wpbforwpbakerypro-myaccount-form-register">

                <h2><?php esc_html_e( 'Register', 'wpbforwpbakerypro' ); ?></h2>

                <form method="post" class="woocommerce-form woocommerce-form-register register" <?php do_action( 'woocommerce_register_form_tag' ); ?> >
        
                    <?php do_action( 'woocommerce_register_form_start' ); ?>
        
                    <?php if ( 'no' === get_option( 'woocommerce_registration_generate_username' ) ) : ?>
        
                        <p class="woocommerce-form-row woocommerce-form-row--wide form-row form-row-wide">
                            <label for="reg_username"><?php esc_html_e( 'Username', 'wpbforwpbakerypro' ); ?>&nbsp;<span class="required">*</span></label>
                            <input type="text" class="woocommerce-Input woocommerce-Input--text input-text" name="username" id="reg_username" autocomplete="username" value="<?php echo ( ! empty( $_POST['username'] ) ) ? esc_attr( wp_unslash( $_POST['username'] ) ) : ''; ?>" /><?php // @codingStandardsIgnoreLine ?>
                        </p>
        
                    <?php endif; ?>
        
                    <p class="woocommerce-form-row woocommerce-form-row--wide form-row form-row-wide">
                        <label for="reg_email"><?php esc_html_e( 'Email address', 'wpbforwpbakerypro' ); ?>&nbsp;<span class="required">*</span></label>
                        <input type="email" class="woocommerce-Input woocommerce-Input--text input-text" name="email" id="reg_email" autocomplete="email" value="<?php echo ( ! empty( $_POST['email'] ) ) ? esc_attr( wp_unslash( $_POST['email'] ) ) : ''; ?>" /><?php // @codingStandardsIgnoreLine ?>
                    </p>
        
                    <?php if ( 'no' === get_option( 'woocommerce_registration_generate_password' ) ) : ?>
        
                        <p class="woocommerce-form-row woocommerce-form-row--wide form-row form-row-wide">
                            <label for="reg_password"><?php esc_html_e( 'Password', 'wpbforwpbakerypro' ); ?>&nbsp;<span class="required">*</span></label>
                            <input type="password" class="woocommerce-Input woocommerce-Input--text input-text" name="password" id="reg_password" autocomplete="new-password" />
                        </p>
        
                    <?php endif; ?>
        
                    <?php do_action( 'woocommerce_register_form' ); ?>
        
                    <p class="woocommerce-FormRow form-row">
                        <?php wp_nonce_field( 'woocommerce-register', 'woocommerce-register-nonce' ); ?>
                        <button type="submit" class="woocommerce-Button button" name="register" value="<?php esc_attr_e( 'Register', 'wpbforwpbakerypro' ); ?>"><?php esc_html_e( 'Register', 'wpbforwpbakerypro' ); ?></button>
                    </p>
        
                    <?php do_action( 'woocommerce_register_form_end' ); ?>
        
                </form>
            </div>
            <?php

		echo '</div>';
        return $output.= ob_get_clean();

    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: My Account Register Form", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_myaccount_register_form",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_myaccount_register_form_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'form_heading_color',
            	    'heading' => esc_html__( 'Heading Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_heading_font_size',
            	    'heading' => esc_html__( 'Heading Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_heading_line_height',
            	    'heading' => esc_html__( 'Heading Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),

            	array(
            	    'param_name' => 'form_label_color',
            	    'heading' => esc_html__( 'Label Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_label_font_size',
            	    'heading' => esc_html__( 'Label Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_label_line_height',
            	    'heading' => esc_html__( 'Label Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),

            	array(
            	    'param_name' => 'form_text_color',
            	    'heading' => esc_html__( 'Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_text_font_size',
            	    'heading' => esc_html__( 'Text Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_text_line_height',
            	    'heading' => esc_html__( 'Text Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),

            	array(
            	    'param_name' => 'form_input_box_color',
            	    'heading' => esc_html__( 'Input Box Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'form_input_box_font_size',
            	    'heading' => esc_html__( 'Input Box Font Size', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 23px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_input_box_line_height',
            	    'heading' => esc_html__( 'Input Box Line Height', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 25px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_input_box_border',
            	    'heading' => esc_html__( 'Input Box Border', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'Ex: 1px solid red', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_input_box_border_radius',
            	    'heading' => esc_html__( 'Input Box Border Radius', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS Border Radius. Example: 5px, which stand for border-radius:5px;', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_input_box_padding',
            	    'heading' => esc_html__( 'Input Box Padding', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS padding. Example: 18px 0, which stand for padding-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),

            	array(
            	    'param_name' => 'form_button_padding',
            	    'heading' => esc_html__( 'Button Padding', 'wpbforwpbakerypro' ),
            	    'type' => 'textfield',
            	    'description' => esc_html__( 'The CSS padding. Example: 18px 0, which stand for padding-top and padding-bottom is 18px', 'wpbforwpbakerypro' ),
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_button_bg_color',
            	    'heading' => esc_html__( 'Button BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_button_text_color',
            	    'heading' => esc_html__( 'Button Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_button_hover_bg_color',
            	    'heading' => esc_html__( 'Button Hover BG Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	array(
            	    'param_name' => 'form_button_hover_text_color',
            	    'heading' => esc_html__( 'Button Hover Text Color', 'wpbforwpbakerypro' ),
            	    'type' => 'colorpicker',
                    'edit_field_class' => 'vc_col-sm-6 vc_column',
            	),
            	
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", "wpbforwpbakerypro" ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}
new WPBForWPbakeryPro_Myaccount_Register_Form();