<?php

// don't load directly
if (!defined('ABSPATH')) die('-1');

if(!class_exists('WPBForWPbakery_Product_Stock')){
	


class WPBForWPbakery_Product_Stock{
    function __construct() {

        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_product_stock', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
        	'in_stock_text_color' => '', 
        	'out_of_stock_text_color' => '',
            'use_google_font' => '', 
            'google_font' => 'font_family:Abril Fatface|font_style:400 regular', 
            'el_class' => '', 
            'wrapper_css' => '', 
        ),$atts));


        global $product;
        $product = wc_get_product();
        if ( empty( $product ) ) { return; }

        ob_start();

         $font_inline_style = '';
        if($use_google_font == 'true'){
            $font_data = wpbforwpbakerypro_get_fonts_data( $google_font );
            wpbforwpbakerypro_enqueue_google_font( $font_data );
            $font_inline_style = wpbforwpbakerypro_get_font_inline_style( $font_data );
        }

        $unique_class = uniqid('wpbforwpbakerypro_product_stock_');
        $output = '<style>';
        $output .= ".$unique_class .stock.in-stock{color: {$in_stock_text_color} !important;}";
        $output .= ".$unique_class .stock{ {$font_inline_style} }";
        $output .= ".$unique_class .stock.out-of-stock{color: {$out_of_stock_text_color} !important;}";
        $output .= '</style>';
        
        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) .wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ') .'">';

        echo wc_get_stock_html( $product );

        echo '</div>';

        return $output.= ob_get_clean();
    }


    public function integrateWithVC() {
    
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => __("WCB: Product Stock", 'wpbforwpbakery'),
            "base" => "wpbforwpbakery_product_stock",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_product_stock_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => __('WC Builder', 'wpbforwpbakery'),
            "params" => array(
            	array(
            	    'param_name' => 'in_stock_text_color',
            	    'heading' => __( 'In Stock Text Color', 'wpbforwpbakery' ),
            	    'type' => 'colorpicker',
            	),
            	array(
            	    'param_name' => 'out_of_stock_text_color',
            	    'heading' => __( 'Out Of Stock Text Color', 'wpbforwpbakery' ),
            	    'type' => 'colorpicker',
            	),
                array(
                    'type' => 'checkbox',
                    'heading' => __( 'Use google font?', 'wpbforwpbakery' ),
                    'param_name' => 'use_google_font',
                    'description' => __( 'Use font family from google font.', 'wpbforwpbakery' ),
                  ),
                  array(
                    'type' => 'google_fonts',
                    'param_name' => 'google_font',
                    'settings' => array(
                      'fields' => array(
                        'font_family_description' => __( 'Select font family.', 'wpbforwpbakery' ),
                        'font_style_description' => __( 'Select font styling.', 'wpbforwpbakery' ),
                      ),
                    ),
                    'dependency' =>[
                        'element' => 'use_google_font',
                        'value' => array( 'true' ),
                    ],
                  ),
                array(
                    'param_name' => 'el_class',
                    'heading' => __( 'Extra class name', 'wpbforwpbakery' ),
                    'type' => 'textfield',
                    'description' => __( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakery' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => __( "Wrapper Styling", "wpbforwpbakery" ),
                  "type" => "css_editor",
                  'group'  => __( 'Wrapper Styling', 'wpbforwpbakery' ),
              ),
            )
        ) );
    }
}

new WPBForWPbakery_Product_Stock();

}