<?php
class WPBForWPbakeryPro_Thankyou_Order{
    function __construct() {
        // creating shortcode addon
        add_shortcode( 'wpbforwpbakery_thankyou_order', array( $this, 'render_shortcode' ) );

        // We safely integrate with VC with this hook
        add_action( 'vc_after_init', array( $this, 'integrateWithVC' ) );
    }

    public function render_shortcode( $atts, $content = null ) {
        extract(shortcode_atts(array(
            'order_thankyou_message' => esc_html__('Thank you. Your order has been received.', 'wpbforwpbakerypro'), 
            'el_class' => '', 
            'wrapper_css' => '', 
        ),$atts));

        ob_start();

        $unique_class = uniqid('wpbforwpbakerypro_');
        $output = '';

        echo '<div class="'. esc_attr($el_class . ' ' . $unique_class) . esc_attr(wpbforwpbakerypro_get_vc_custom_class($wrapper_css, ' ')) .'">';

        global $wp;
        
        if( isset($wp->query_vars['order-received']) ){
            $received_order_id = $wp->query_vars['order-received'];
        }else{
            $received_order_id = wpbforwpbakerypro_get_last_order_id();
        }
        $order = wc_get_order( $received_order_id );

        ?>
        
        <?php if ( $order ) : ?>

            <?php if ( $order->has_status( 'failed' ) ) : ?>
        
                <p class="woocommerce-notice woocommerce-notice--error woocommerce-thankyou-order-failed"><?php esc_html_e( 'Unfortunately your order cannot be processed as the originating bank/merchant has declined your transaction. Please attempt your purchase again.', 'wpbforwpbakerypro' ); ?></p>
        
                <p class="woocommerce-notice woocommerce-notice--error woocommerce-thankyou-order-failed-actions">
                    <a href="<?php echo esc_url( $order->get_checkout_payment_url() ); ?>" class="button pay"><?php esc_html_e( 'Pay', 'wpbforwpbakerypro' ) ?></a>
                    <?php if ( is_user_logged_in() ) : ?>
                        <a href="<?php echo esc_url( wc_get_page_permalink( 'myaccount' ) ); ?>" class="button pay"><?php esc_html_e( 'My account', 'wpbforwpbakerypro' ); ?></a>
                    <?php endif; ?>
                </p>
        
            <?php else : ?>
        
                <p class="woocommerce-notice woocommerce-notice--success woocommerce-thankyou-order-received"><?php echo apply_filters( 'woocommerce_thankyou_order_received_text', $order_thankyou_message, $order ); ?></p>
        
                <ul class="woocommerce-order-overview woocommerce-thankyou-order-details order_details">
        
                    <li class="woocommerce-order-overview__order order">
                        <?php esc_html_e( 'Order number:', 'wpbforwpbakerypro' ); ?>
                        <strong><?php echo esc_html($order->get_order_number()); ?></strong>
                    </li>
        
                    <li class="woocommerce-order-overview__date date">
                        <?php esc_html_e( 'Date:', 'wpbforwpbakerypro' ); ?>
                        <strong><?php echo wc_format_datetime( $order->get_date_created() ); ?></strong>
                    </li>
        
                    <?php if ( is_user_logged_in() && $order->get_user_id() === get_current_user_id() && $order->get_billing_email() ) : ?>
                        <li class="woocommerce-order-overview__email email">
                            <?php esc_html_e( 'Email:', 'wpbforwpbakerypro' ); ?>
                            <strong><?php echo wp_kses_post( $order->get_billing_email() ); ?></strong>
                        </li>
                    <?php endif; ?>
        
                    <li class="woocommerce-order-overview__total total">
                        <?php esc_html_e( 'Total:', 'wpbforwpbakerypro' ); ?>
                        <strong><?php echo wp_kses_post( $order->get_formatted_order_total() ); ?></strong>
                    </li>
        
                    <?php if ( $order->get_payment_method_title() ) : ?>
                        <li class="woocommerce-order-overview__payment-method method">
                            <?php esc_html_e( 'Payment method:', 'wpbforwpbakerypro' ); ?>
                            <strong><?php echo wp_kses_post( $order->get_payment_method_title() ); ?></strong>
                        </li>
                    <?php endif; ?>
        
                </ul>
        
            <?php endif; ?>
        
            <?php do_action( 'woocommerce_thankyou_' . $order->get_payment_method(), $order->get_id() ); ?>
        
        <?php else : ?>
        
            <p class="woocommerce-notice woocommerce-notice--success woocommerce-thankyou-order-received"><?php echo apply_filters( 'woocommerce_thankyou_order_received_text', $order_thankyou_message, null ); ?></p>
        
        <?php endif; ?>
        
        <?php

    	echo '</div>';
        return $output.= ob_get_clean();
    }

    public function integrateWithVC() {
        /*
        Lets call vc_map function to "register" our custom shortcode within WPBakery Page Builder interface.

        More info: http://kb.wpbakery.com/index.php?title=Vc_map
        */
        vc_map( array(
            "name" => esc_html__("WCB: Thank You Order", 'wpbforwpbakerypro'),
            "base" => "wpbforwpbakery_thankyou_order",
            "class" => "",
            "controls" => "full",
            "icon" => 'wpbforwpbakerypro_thankyou_order_icon', // or css class name which you can reffer in your css file later. Example: "vc_extend_my_class"
            "category" => esc_html__('WC Builder', 'wpbforwpbakerypro'),
            "params" => array(
            	array(
            	    'param_name' => 'order_thankyou_message',
            	    'heading' => esc_html__( 'Thank You Message', 'wpbforwpbakerypro' ),
            	    'type' => 'textarea',
            	    'std'	=> esc_html__('Thank you. Your order has been received.', 'wpbforwpbakerypro')
            	),
                array(
                    'param_name' => 'el_class',
                    'heading' => esc_html__( 'Extra class name', 'wpbforwpbakerypro' ),
                    'type' => 'textfield',
                    'description' => esc_html__( 'Style this element differently - add a class name and refer to it in custom CSS.', 'wpbforwpbakerypro' ),
                ),
                array(
                  "param_name" => "wrapper_css",
                  "heading" => esc_html__( "Wrapper Styling", 'wpbforwpbakerypro' ),
                  "type" => "css_editor",
                  'group'  => esc_html__( 'Wrapper Styling', 'wpbforwpbakerypro' ),
              ),
            )
        ) );
    }
}

new WPBForWPbakeryPro_Thankyou_Order();