<?php
/**
*  Customize WooCommerce Configurations
*/
class WPBForWPbakeryPro_Woo_Config{

    public static $wpb_woo_wpbakery_template = array();

    private static $_instance = null;
    public static function instance() {
        if ( is_null( self::$_instance ) ) {
            self::$_instance = new self();
        }
        return self::$_instance;
    }
    
    public function __construct(){
        add_action('init', array( $this, 'init' ) );
    }

    public function init(){
	    add_action('template_redirect', array($this, 'wpbforwpbakerypro_product_archive_template'), 999);

	    // set our archive-product-fullwidth.php file 
	    add_filter('template_include', array($this, 'wpbforwpbakerypro_redirect_product_archive_template'), 999);

	    // add page content by hook located in woo-templates/archive-product.php
	    add_action( 'wpbforwpbakerypro_woocommerce_archive_product_content', array( $this, 'wpbforwpbakerypro_archive_product_page_content') );

	    // add product data generate by hook
	    add_action( 'wpbforwpbakerypro_woocommerce_archive_product_content', array( $this, 'wl_get_default_product_data'), 15 );

	    // set our single-product-fullwidth.php file 
		add_filter( 'template_include', array( $this, 'wpbforwpbakerypro_single_product_template' ), 100 );

	    // set our content-product.php file 
		add_filter( 'wc_get_template_part', array( $this, 'wpbforwpbakerypro_get_product_page_template' ), 99, 3 );

		// add page content by hook located in woo-templates/content-single-product.php
		add_action( 'wpbforwpbakerypro_woocommerce_product_content', array( $this, 'wpbforwpbakerypro_get_product_content_wpbakery' ), 5 );




		// set our header-footer.php template for cart, mayccout, checkout and other page while full width
		add_filter( 'template_include', array($this, 'wpbforwpbakerypro_woocommerce_page_template'), 999);

    	add_filter( 'wc_get_template', array( $this, 'page_template' ), 50, 3 );

        // Cart template content
        add_action( 'wpbforwpbakerypro_cart_content_build', array( $this, 'cart_content' ) );

        // checkout template content
        add_action( 'wpbforwpbakerypro_checkout_content', array( $this, 'checkout_content' ) );

        // MyAccount template content
        add_action( 'wpbforwpbakerypro_woocommerce_account_content', array( $this, 'myaccount_content' ) );
        add_action( 'wpbforwpbakerypro_woocommerce_account_content_form_login', array( $this, 'myaccount_login_content' ) );

        // thankyou template content
        add_action( 'wpbforwpbakerypro_thankyou_content', array( $this, 'thankyou_content' ) );

        // Redirect after add to cart
        if( wpbforwpbakerypro_get_option('redirect_add_to_cart', 'wpbforwpbakery_other_tabs') === 'on' ){
           add_filter( 'woocommerce_add_to_cart_redirect', array( $this, 'redirect_checkout_add_cart' ) ); 
        }
    }

    /*
    * Archive Page
    */
    public function wpbforwpbakerypro_product_archive_template() {
        $archive_template_id = 0;
        if ( defined('WOOCOMMERCE_VERSION') ) {
            if ( is_shop() || ( is_tax('product_cat') && is_product_category() ) || ( is_tax('product_tag') && is_product_tag() ) ) {
                $product_achive_custom_page_id = wpbforwpbakerypro_get_option( 'productarchivepage', 'wpbforwpbakery_woo_template_tabs', '0' );

                // Meta value
                $wpbtermlayoutid = 0;
                $termobj = get_queried_object();
                if(( is_tax('product_cat') && is_product_category() ) || ( is_tax('product_tag') && is_product_tag() )){
                    $wpbtermlayoutid = get_term_meta( $termobj->term_id, 'wpbforwpbakery_selectcategory_layout', true ) ? get_term_meta( $termobj->term_id, 'wpbforwpbakery_selectcategory_layout', true ) : '0';
                }
                if( $wpbtermlayoutid != '0' ){ 
                    $archive_template_id = $wpbtermlayoutid; 
                }else{
                    if (!empty($product_achive_custom_page_id)) {
                        $archive_template_id = $product_achive_custom_page_id;
                    }
                }
                return $archive_template_id;
            }
            return $archive_template_id;
        }
    }

    public function wpbforwpbakerypro_redirect_product_archive_template($template){
    	$archive_template_id = $this->wpbforwpbakerypro_product_archive_template();
    	$layout = get_post_meta($archive_template_id, 'wpbforwpbakery_tmpl_layout', true);
    	$enablecustomlayout = wpbforwpbakerypro_get_option( 'enablecustomlayout', 'wpbforwpbakery_woo_template_tabs', '0' );
    	
        if( $archive_template_id &&  $enablecustomlayout == 'on' && $layout == 'Full Width'){
            $template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . '/woo-templates/archive-product-fullwidth.php';
        } elseif($archive_template_id &&  $enablecustomlayout == 'on' && $layout == 'Default'){
        	 $template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . '/woo-templates/archive-product.php';
        }
        
        return $template;
    }

    // Archive Page Content
    public function wpbforwpbakerypro_archive_product_page_content( $post ){
        $archive_template_id = $this->wpbforwpbakerypro_product_archive_template();
        if( $archive_template_id ){
        	if ($wpb_custom_css = get_post_meta($archive_template_id, '_wpb_post_custom_css', true)) {
        		echo '<style type="text/css">' . $wpb_custom_css . '</style>';
        	}
        	if ($wpb_shortcodes_custom_css = get_post_meta($archive_template_id, '_wpb_shortcodes_custom_css', true)) {
        		echo '<style type="text/css">' . $wpb_shortcodes_custom_css . '</style>';
        	}

        	$product_archive_custom_page = get_post($archive_template_id);
            $content = $product_archive_custom_page->post_content;
            $content = apply_filters( 'the_content', $content );
            $content = str_replace( ']]>', ']]&gt;', $content );
            echo $content;
        } else{ 
        	the_content();
        }
    }

    // product data
    public function wl_get_default_product_data() {
        WC()->structured_data->generate_product_data();
    }



    // single-product-fullwidth.php
    public function wpbforwpbakerypro_single_product_template( $template ) {
    	$custom_single_page_id = wpbforwpbakerypro_get_option( 'singleproductpage', 'wpbforwpbakery_woo_template_tabs', '0' );
    	$individual_product_tmpl_id = get_post_meta( get_the_id(), '_selectproduct_layout', true );
    	if(!empty($individual_product_tmpl_id)){
    		$custom_single_page_id = $individual_product_tmpl_id;
    	}

    	$layout = get_post_meta($custom_single_page_id, 'wpbforwpbakery_tmpl_layout', true);
    	$enablecustomlayout = wpbforwpbakerypro_get_option( 'enablecustomlayout', 'wpbforwpbakery_woo_template_tabs', '0' );

        if ( is_embed() ) {
            return $template;
        }
        if ( $enablecustomlayout == 'on' && $layout == 'Full Width' && (is_singular( 'product' ) && (int) $custom_single_page_id)) {
             $template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . 'woo-templates/single-product-fullwidth.php';
        }
        return $template;
    }

    /*
    * content-single-product.php
    */
    public function wpbforwpbakerypro_get_product_page_template( $template, $slug, $name ) {
    	$custom_single_page_id = wpbforwpbakerypro_get_option( 'singleproductpage', 'wpbforwpbakery_woo_template_tabs', '0' );
    	$individual_product_tmpl_id = get_post_meta( get_the_id(), '_selectproduct_layout', true );
    	if(!empty($individual_product_tmpl_id)){
    		$custom_single_page_id = $individual_product_tmpl_id;
    	}

    	$layout = get_post_meta($custom_single_page_id, 'wpbforwpbakery_tmpl_layout', true);
    	$enablecustomlayout = wpbforwpbakerypro_get_option( 'enablecustomlayout', 'wpbforwpbakery_woo_template_tabs', '0' );

        if ( $enablecustomlayout == 'on' && ($layout == 'Default' ||  $layout == 'Full Width' ) && ('content' === $slug && 'single-product' === $name) ) {
            if ( WPBForWPbakeryPro_Woo_Config::wl_woo_custom_product_template() ) {
                $template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . 'woo-templates/content-single-product.php';
            }
        } 
        return $template;
    }

    public static function wpbforwpbakerypro_get_product_content_wpbakery( $post ) {
        if ( WPBForWPbakeryPro_Woo_Config::wl_woo_custom_product_template() ) {
            $wpbtemplateid = wpbforwpbakerypro_get_option( 'singleproductpage', 'wpbforwpbakery_woo_template_tabs', '0' );
            $wpbindividualid = get_post_meta( get_the_ID(), '_selectproduct_layout', true ) ? get_post_meta( get_the_ID(), '_selectproduct_layout', true ) : '0';
            if( $wpbindividualid != '0' ){ $wpbtemplateid = $wpbindividualid; }



        	if ($wpb_custom_css = get_post_meta($wpbtemplateid, '_wpb_post_custom_css', true)) {
        		echo '<style type="text/css">' . $wpb_custom_css . '</style>';
        	}
        	if ($wpb_shortcodes_custom_css = get_post_meta($wpbtemplateid, '_wpb_shortcodes_custom_css', true)) {
        		echo '<style type="text/css">' . $wpb_shortcodes_custom_css . '</style>';
        	}

        	$product_archive_custom_page = get_post($wpbtemplateid);
            $content = $product_archive_custom_page->post_content;
            $content = apply_filters( 'the_content', $content );
            $content = str_replace( ']]>', ']]&gt;', $content );
            echo $content;
        } else {
            the_content();
        }
    }


    public static function wl_woo_custom_product_template() {
        $templatestatus = false;
        if ( is_product() ) {
            global $post;
            if ( ! isset( self::$wpb_woo_wpbakery_template[ $post->ID ] ) ) {
                $single_product_default = wpbforwpbakerypro_get_option( 'singleproductpage', 'wpbforwpbakery_woo_template_tabs', '0' );
                if ( ! empty( $single_product_default ) && 'default' !== $single_product_default ) {
                    $templatestatus                              = true;
                    self::$wpb_woo_wpbakery_template[ $post->ID ] = true;
                }
            } else {
                $templatestatus = self::$wpb_woo_wpbakery_template[ $post->ID ];
            }
        }
        return true;
    }


	public function wpbforwpbakerypro_woocommerce_page_template( $template ){
		$enablecustomlayout = wpbforwpbakerypro_get_option( 'enablecustomlayout', 'wpbforwpbakery_woo_template_tabs', '0' );
		$layout = '';

		if($enablecustomlayout == 'on'){
			if( is_cart() ){
				$cart_page_id = wpbforwpbakerypro_get_option( 'productcartpage', 'wpbforwpbakery_woo_template_tabs', '0' );
				$layout = get_post_meta($cart_page_id, 'wpbforwpbakery_tmpl_layout', true);
			} elseif ( is_checkout() ){ 
				$checkout_page_id = wpbforwpbakerypro_get_option( 'productcheckoutpage', 'wpbforwpbakery_woo_template_tabs', '0' );
				$layout = get_post_meta($checkout_page_id, 'wpbforwpbakery_tmpl_layout', true);
			} elseif ( is_account_page() && is_user_logged_in() ){
				$myaccount_page_id = wpbforwpbakerypro_get_option( 'productmyaccountpage', 'wpbforwpbakery_woo_template_tabs', '0' );
				$layout = get_post_meta($myaccount_page_id, 'wpbforwpbakery_tmpl_layout', true);
			}

	        if($layout == 'Full Width'){
	        	$template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . 'woo-templates/header-footer.php';
	        }
		}

		return $template;
	}


    public function page_template( $template, $slug, $args ){
    	$custom_template_enable = wpbforwpbakerypro_get_option( 'enablecustomlayout', 'wpbforwpbakery_woo_template_tabs', 'on' );
        
        if( $slug === 'cart/cart.php' && $custom_template_enable == 'on'){

            $cart_page_id = wpbforwpbakerypro_get_option( 'productcartpage', 'wpbforwpbakery_woo_template_tabs', '0' );
            if( !empty( $cart_page_id ) ) {
                $template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . 'woo-templates/cart.php';
            }

        }elseif( $slug === 'checkout/form-checkout.php'  && $custom_template_enable == 'on' ){

            $checkout_page_id = wpbforwpbakerypro_get_option( 'productcheckoutpage', 'wpbforwpbakery_woo_template_tabs', '0' );
            if( !empty( $checkout_page_id ) && $custom_template_enable == 'on' ) {
                $template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . 'woo-templates/form-checkout.php';
            }

        }elseif( $slug === 'checkout/thankyou.php'  && $custom_template_enable == 'on' ){

            $thankyou_page_id = wpbforwpbakerypro_get_option( 'productthankyoupage', 'wpbforwpbakery_woo_template_tabs', '0' );
            if( !empty( $thankyou_page_id ) && $custom_template_enable == 'on' ) {
                $template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . 'woo-templates/thankyou.php';
            }

        }elseif( $slug === 'myaccount/my-account.php' && $custom_template_enable == 'on' ){

            $myaccount_page_id = wpbforwpbakerypro_get_option( 'productmyaccountpage', 'wpbforwpbakery_woo_template_tabs', '0' );
            if( !empty( $myaccount_page_id ) ) {
                $template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . 'woo-templates/my-account.php';
            }

        }elseif( $slug === 'myaccount/form-login.php'  && $custom_template_enable == 'on' ){

            $myaccount_login_page_id = wpbforwpbakerypro_get_option( 'productmyaccountloginpage', 'wpbforwpbakery_woo_template_tabs', '0' );
            if( !empty( $myaccount_login_page_id ) ) {
                $template = WPBFORWPBAKERY_PRO_ADDONS_PL_PATH . 'woo-templates/form-login.php';
            }

        }

        return $template;
    }
    
    public function cart_content(){
        $templateid = wpbforwpbakerypro_get_option( 'productcartpage', 'wpbforwpbakery_woo_template_tabs', '0' );
        $wpb_custom_css = get_post_meta($templateid, '_wpb_post_custom_css', true);
        $wpb_shortcodes_custom_css = get_post_meta($templateid, '_wpb_shortcodes_custom_css', true);

    	if ( $wpb_custom_css ) {
    		echo '<style type="text/css">' . $wpb_custom_css . '</style>';
    	}
    	if ( $wpb_shortcodes_custom_css ) {
    		echo '<style type="text/css">' . $wpb_shortcodes_custom_css . '</style>';
    	}

    	$product_archive_custom_page = get_post($templateid);
        $content = $product_archive_custom_page->post_content;
        $content = apply_filters( 'the_content', $content );
        $content = str_replace( ']]>', ']]&gt;', $content );

        echo ( $content );
    }

    public function checkout_content(){
        $templateid = wpbforwpbakerypro_get_option( 'productcheckoutpage', 'wpbforwpbakery_woo_template_tabs', '0' );
        $wpb_custom_css = get_post_meta($templateid, '_wpb_post_custom_css', true);
        $wpb_shortcodes_custom_css = get_post_meta($templateid, '_wpb_shortcodes_custom_css', true);

    	if ( $wpb_custom_css ) {
    		echo '<style type="text/css">' . $wpb_custom_css . '</style>';
    	}
    	if ( $wpb_shortcodes_custom_css ) {
    		echo '<style type="text/css">' . $wpb_shortcodes_custom_css . '</style>';
    	}

    	$product_archive_custom_page = get_post($templateid);
        $content = $product_archive_custom_page->post_content;
        $content = apply_filters( 'the_content', $content );
        $content = str_replace( ']]>', ']]&gt;', $content );

        echo ( $content );
    }

    public function myaccount_content(){
        $templateid = wpbforwpbakerypro_get_option( 'productmyaccountpage', 'wpbforwpbakery_woo_template_tabs', '0' );
        $wpb_custom_css = get_post_meta($templateid, '_wpb_post_custom_css', true);
        $wpb_shortcodes_custom_css = get_post_meta($templateid, '_wpb_shortcodes_custom_css', true);

    	if ( $wpb_custom_css ) {
    		echo '<style type="text/css">' . $wpb_custom_css . '</style>';
    	}
    	if ( $wpb_shortcodes_custom_css ) {
    		echo '<style type="text/css">' . $wpb_shortcodes_custom_css . '</style>';
    	}

    	$product_archive_custom_page = get_post($templateid);
        $content = $product_archive_custom_page->post_content;
        $content = apply_filters( 'the_content', $content );
        $content = str_replace( ']]>', ']]&gt;', $content );

        echo ( $content );
    }

    public function myaccount_login_content(){
        $templateid = wpbforwpbakerypro_get_option( 'productmyaccountloginpage', 'wpbforwpbakery_woo_template_tabs', '0' );
        $wpb_custom_css = get_post_meta($templateid, '_wpb_post_custom_css', true);
        $wpb_shortcodes_custom_css = get_post_meta($templateid, '_wpb_shortcodes_custom_css', true);

    	if ( $wpb_custom_css ) {
    		echo '<style type="text/css">' . $wpb_custom_css . '</style>';
    	}
    	if ( $wpb_shortcodes_custom_css ) {
    		echo '<style type="text/css">' . $wpb_shortcodes_custom_css . '</style>';
    	}

    	$product_archive_custom_page = get_post($templateid);
        $content = $product_archive_custom_page->post_content;
        $content = apply_filters( 'the_content', $content );
        $content = str_replace( ']]>', ']]&gt;', $content );

        echo ( $content );
    }

    public function thankyou_content(){
	    $templateid = wpbforwpbakerypro_get_option( 'productthankyoupage', 'wpbforwpbakery_woo_template_tabs', '0' );
	    $wpb_custom_css = get_post_meta($templateid, '_wpb_post_custom_css', true);
	    $wpb_shortcodes_custom_css = get_post_meta($templateid, '_wpb_shortcodes_custom_css', true);

		if ( $wpb_custom_css ) {
			echo '<style type="text/css">' . $wpb_custom_css . '</style>';
		}
		if ( $wpb_shortcodes_custom_css ) {
			echo '<style type="text/css">' . $wpb_shortcodes_custom_css . '</style>';
		}

		$product_archive_custom_page = get_post($templateid);
	    $content = $product_archive_custom_page->post_content;
	    $content = apply_filters( 'the_content', $content );
	    $content = str_replace( ']]>', ']]&gt;', $content );

	    echo ( $content );
    }

    /**
     * [redirect_checkout_add_cart]
     * @return [url] checkout page url
     */
    public function redirect_checkout_add_cart() {
       return wc_get_checkout_url();
    }

}

WPBForWPbakeryPro_Woo_Config::instance();