<?php
/**
 * Checkout Form
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

?>
<div class="woocommerce wpbforwpbakerypro-woocommerce-checkout">

	<?php 
		remove_action( 'woocommerce_before_checkout_form', 'woocommerce_checkout_coupon_form', 10 );
		remove_action( 'woocommerce_before_checkout_form', 'woocommerce_checkout_login_form', 10 );
	?>
	<?php
		do_action( 'woocommerce_before_checkout_form', $checkout );
		// If checkout registration is disabled and not logged in, the user cannot checkout.
		if ( ! $checkout->is_registration_enabled() && $checkout->is_registration_required() && ! is_user_logged_in() ) {
			echo esc_html( apply_filters( 'woocommerce_checkout_must_be_logged_in_message', esc_html__( 'You must be logged in to checkout.', 'wpbforwpbakerypro' ) ) );
			return;
		}
	?>
	<div class="wpbforwpbakerypro_checkout">
	
		<?php
			woocommerce_checkout_coupon_form();
			woocommerce_checkout_login_form();
		?>

	</div>
	<form name="checkout" method="post" class="checkout woocommerce-checkout" action="<?php echo esc_url( wc_get_checkout_url() ); ?>" enctype="multipart/form-data">
		<?php do_action('wpbforwpbakerypro_checkout_content'); ?>
	</form>
	<?php do_action( 'woocommerce_after_checkout_form', $checkout ); ?>
</div>